LeetCode题解:Nim Game

来源:互联网 发布:达内大数据视频百度云 编辑:程序博客网 时间:2024/06/03 16:23

You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.

Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.

For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.

Hint:

If there are 5 stones in the heap, could you figure out a way to remove the stones such that you will always be the winner?

题意:有n个石头,两个人轮流拿走1/2/3个石头,谁先拿走最后一个石头谁就赢,假设你是先手方,判断你能不能赢。(假设每个人都会选择最优策略)

思路:我们输的可能只有一种,就是n%4==0的情况。因为我们是先手,所以在n%4!=0时,无论怎么样都不会输(假如始终选择最优策略)

代码:

public class Solution {    public boolean canWinNim(int n) {        return n % 4 != 0;    }}
0 0
原创粉丝点击